// Plik specyfikacji klasy FeetInches
#ifndef FEETINCHES_H
#define FEETINCHES_H

#include <iostream>
using namespace std;

class FeetInches; // Deklaracja wyprzedzajca

// Prototypy funkcji przeciajcych operatory strumieniowe
ostream &operator << (ostream &, const FeetInches &);
istream &operator >> (istream &, FeetInches &);

// Klasa FeetInches zawiera odlego
// lub wymiar wyraony w stopach i calach.

class FeetInches
{
private:
  int feet;         // Zmienna zawierajca liczb stp
  int inches;       // Zmienna zawierajca liczb cali
  void simplify();  // Funkcja zdefiniowana w pliku FeetInches.cpp
public:
  // Konstruktor
  FeetInches(int f = 0, int i = 0)
    { feet = f;
      inches = i;
      simplify(); }

  // Mutatory
  void setFeet(int f)
    { feet = f; }

  void setInches(int i)
    { inches = i;
      simplify(); }

  // Akcesory
  int getFeet() const
    { return feet; }

  int getInches() const
    { return inches; }

  // Funkcje przecionych operatorw
  FeetInches operator + (const FeetInches &); // Przeciony operator +
  FeetInches operator - (const FeetInches &); // Przeciony operator -
  FeetInches operator ++ ();     // Przeciony prefiksowy operator ++
  FeetInches operator ++ (int);  // Przeciony sufiksowy operator ++
  bool operator > (const FeetInches &);  // Przeciony operator >
  bool operator < (const FeetInches &);  // Przeciony operator <
  bool operator == (const FeetInches &); // Przeciony operator ==
  bool operator != (const FeetInches &); // Przeciony operator !=

  // Funkcje konwertujce
  operator double();
  operator int();

  // Funkcje zaprzyjanione
  friend ostream &operator << (ostream &, const FeetInches &);
  friend istream &operator >> (istream &, FeetInches &);
};

#endif